__gnu_cxx::array_allocator< _Tp, _Array > Class Template Reference
Utilities » Memory » Allocators

`#include <array_allocator.h>`

Inheritance diagram for __gnu_cxx::array_allocator< _Tp, _Array >:
[legend]

## Public Types

typedef _Array | array_type
typedef const _Tp * | const_pointer
typedef const _Tp & | const_reference
typedef ptrdiff_t | difference_type
typedef std::true_type | is_always_equal
typedef _Tp * | pointer
typedef std::true_type | propagate_on_container_move_assignment
typedef _Tp & | reference
typedef size_t | size_type
typedef _Tp | value_type

## Public Member Functions

| array_allocator (array_type *__array=0) noexcept
| array_allocator (const array_allocator &__o) noexcept
template<typename _Tp1 , typename _Array1 >
| array_allocator (const array_allocator< _Tp1, _Array1 > &) noexcept
const_pointer | address (const_reference __x) const noexcept
pointer | address (reference __x) const noexcept
_GLIBCXX_NODISCARD pointer | allocate (size_type __n, const void *=0)
template<typename _Up , typename... _Args>
void | construct (_Up *__p, _Args &&... __args)
void | deallocate (pointer, size_type)
template<typename _Up >
void | destroy (_Up *__p)
size_type | max_size () const noexcept

## Detailed Description

template<typename _Tp, typename _Array = std::tr1::array<_Tp, 1>>
class __gnu_cxx::array_allocator< _Tp, _Array >

An allocator that uses previously allocated memory. This memory can be externally, globally, or otherwise allocated.

Definition at line 110 of file array_allocator.h.

## Member Typedef Documentation

## array_type

template<typename _Tp , typename _Array = std::tr1::array<_Tp, 1>>

typedef _Array __gnu_cxx::array_allocator< _Tp, _Array >::array_type

Definition at line 120 of file array_allocator.h.

## const_pointer

template<typename _Tp , typename _Array = std::tr1::array<_Tp, 1>>

typedef const _Tp* __gnu_cxx::array_allocator< _Tp, _Array >::const_pointer

Definition at line 116 of file array_allocator.h.

## const_reference

template<typename _Tp , typename _Array = std::tr1::array<_Tp, 1>>

typedef const _Tp& __gnu_cxx::array_allocator< _Tp, _Array >::const_reference

Definition at line 118 of file array_allocator.h.

## difference_type

template<typename _Tp , typename _Array = std::tr1::array<_Tp, 1>>

typedef ptrdiff_t __gnu_cxx::array_allocator< _Tp, _Array >::difference_type

Definition at line 114 of file array_allocator.h.

## is_always_equal

template<typename _Tp , typename _Array = std::tr1::array<_Tp, 1>>

typedef std::true_type __gnu_cxx::array_allocator< _Tp, _Array >::is_always_equal

Definition at line 127 of file array_allocator.h.

## pointer

template<typename _Tp , typename _Array = std::tr1::array<_Tp, 1>>

typedef _Tp* __gnu_cxx::array_allocator< _Tp, _Array >::pointer

Definition at line 115 of file array_allocator.h.

## propagate_on_container_move_assignment

template<typename _Tp , typename _Array = std::tr1::array<_Tp, 1>>

typedef std::true_type __gnu_cxx::array_allocator< _Tp, _Array >::propagate_on_container_move_assignment

Definition at line 125 of file array_allocator.h.

## reference

template<typename _Tp , typename _Array = std::tr1::array<_Tp, 1>>

typedef _Tp& __gnu_cxx::array_allocator< _Tp, _Array >::reference

Definition at line 117 of file array_allocator.h.

## size_type

template<typename _Tp , typename _Array = std::tr1::array<_Tp, 1>>

typedef size_t __gnu_cxx::array_allocator< _Tp, _Array >::size_type

Definition at line 113 of file array_allocator.h.

## value_type

template<typename _Tp , typename _Array = std::tr1::array<_Tp, 1>>

typedef _Tp __gnu_cxx::array_allocator< _Tp, _Array >::value_type

Definition at line 119 of file array_allocator.h.

## Constructor & Destructor Documentation

## array_allocator() [1/3]

template<typename _Tp , typename _Array = std::tr1::array<_Tp, 1>>

__gnu_cxx::array_allocator< _Tp, _Array >::array_allocator | ( | array_type * | __array = `0` | ) |

inline noexcept

Definition at line 141 of file array_allocator.h.

## array_allocator() [2/3]

template<typename _Tp , typename _Array = std::tr1::array<_Tp, 1>>

__gnu_cxx::array_allocator< _Tp, _Array >::array_allocator | ( | const array_allocator< _Tp, _Array > & | __o | ) |

inline noexcept

Definition at line 144 of file array_allocator.h.

## array_allocator() [3/3]

template<typename _Tp , typename _Array = std::tr1::array<_Tp, 1>>
template<typename _Tp1 , typename _Array1 >

__gnu_cxx::array_allocator< _Tp, _Array >::array_allocator | ( | const array_allocator< _Tp1, _Array1 > & |  | ) |

inline noexcept

Definition at line 148 of file array_allocator.h.

## ~array_allocator()

template<typename _Tp , typename _Array = std::tr1::array<_Tp, 1>>

__gnu_cxx::array_allocator< _Tp, _Array >::~array_allocator | ( |  | ) |

inline noexcept

Definition at line 152 of file array_allocator.h.

## Member Function Documentation

## address() [1/2]

template<typename _Tp >

const_pointer __gnu_cxx::array_allocator_base< _Tp >::address | ( | const_reference | __x | ) | const

inline noexcept inherited

Definition at line 70 of file array_allocator.h.

## address() [2/2]

template<typename _Tp >

pointer __gnu_cxx::array_allocator_base< _Tp >::address | ( | reference | __x | ) | const

inline noexcept inherited

Definition at line 66 of file array_allocator.h.

## allocate()

template<typename _Tp , typename _Array = std::tr1::array<_Tp, 1>>

_GLIBCXX_NODISCARD pointer __gnu_cxx::array_allocator< _Tp, _Array >::allocate | ( | size_type | __n,
|  | const void * | = `0`
| ) |  |

inline

Definition at line 155 of file array_allocator.h.

## construct()

template<typename _Tp >
template<typename _Up , typename... _Args>

void __gnu_cxx::array_allocator_base< _Tp >::construct | ( | _Up * | __p,
|  | _Args &&... | __args
| ) |  |

inline inherited

Definition at line 86 of file array_allocator.h.

## deallocate()

template<typename _Tp >

void __gnu_cxx::array_allocator_base< _Tp >::deallocate | ( | pointer | ,
|  | size_type |
| ) |  |

inline inherited

Definition at line 74 of file array_allocator.h.

## destroy()

template<typename _Tp >
template<typename _Up >

void __gnu_cxx::array_allocator_base< _Tp >::destroy | ( | _Up * | __p | ) |

inline inherited

Definition at line 91 of file array_allocator.h.

## max_size()

template<typename _Tp >

size_type __gnu_cxx::array_allocator_base< _Tp >::max_size | ( |  | ) | const

inline noexcept inherited

Definition at line 80 of file array_allocator.h.

The documentation for this class was generated from the following file:

- array_allocator.h